#include "relais.h"

#include <avr/io.h>

#define RELAIS1_PORT	PORTD
#define RELAIS1_PIN		7
#define RELAIS1_DDR		DDRD

#define RELAIS2_PORT	PORTB
#define RELAIS2_PIN		0
#define RELAIS2_DDR		DDRB

#define RELAIS3_PORT	PORTB
#define RELAIS3_PIN		1
#define RELAIS3_DDR		DDRB

#define RELAIS4_PORT	PORTB
#define RELAIS4_PIN		2
#define RELAIS4_DDR		DDRB


void Relais_Init(void)
{
	RELAIS1_DDR |= (1<<RELAIS1_PIN);
	RELAIS2_DDR |= (1<<RELAIS2_PIN);
	RELAIS3_DDR |= (1<<RELAIS3_PIN);
	RELAIS4_DDR |= (1<<RELAIS4_PIN);

	Relais_Set(0x00);
}

void	Relais_Set(uint8_t r)
{
	if(r & 0x01)
		RELAIS1_PORT |= (1<<RELAIS1_PIN);
	else
		RELAIS1_PORT &= ~(1<<RELAIS1_PIN);

	if(r & 0x02)
		RELAIS2_PORT |= (1<<RELAIS2_PIN);
	else
		RELAIS2_PORT &= ~(1<<RELAIS2_PIN);

	if(r & 0x04)
		RELAIS3_PORT |= (1<<RELAIS3_PIN);
	else
		RELAIS3_PORT &= ~(1<<RELAIS3_PIN);

	if(r & 0x08)
		RELAIS4_PORT |= (1<<RELAIS4_PIN);
	else
		RELAIS4_PORT &= ~(1<<RELAIS4_PIN);
}
