#include "ring_buffer16.h"

void RingBuffer16_Push(RingBuffer16Data word, struct SRingBuffer16 * ring_buffer)
{
	ring_buffer->data[ring_buffer->head] = word;

	//keep pointer in valid memory
	if(ring_buffer->head < ring_buffer->size - 1)
		ring_buffer->head++;
    else
        ring_buffer->head = 0;
}

RingBuffer16Data RingBuffer16_Pop( struct SRingBuffer16 * ring_buffer)
{
	RingBuffer16Data word = ring_buffer->data[ring_buffer->tail];

	//keep pointer in valid memory
	if(ring_buffer->tail < ring_buffer->size - 1)
		ring_buffer->tail++;
    else
        ring_buffer->tail = 0;

	return word;
}

RingBuffer16Size	RingBuffer16_Size( struct SRingBuffer16 * ring_buffer)
{
    if(ring_buffer->head >= ring_buffer->tail)
        return ring_buffer->head - ring_buffer->tail;
    else
        return ring_buffer->size - ring_buffer->tail + ring_buffer->head;
}

void RingBuffer16_Clear( struct SRingBuffer16 * ring_buffer)
{
	ring_buffer->head = 0;
	ring_buffer->tail = 0;
}

void RingBuffer16_Init( struct SRingBuffer16 * ring_buffer, RingBuffer16Data * volatile data, RingBuffer16Size size)
{
	//set size to zero and init the 2 pointer
	ring_buffer->size = size;
	ring_buffer->data = data;
	ring_buffer->head = 0;
	ring_buffer->tail = 0;
}

