#pragma once

#include <inttypes.h>


/**
* \brief	Init the SPI module.
*/
void SPI_Init(void);

/**
* \brief	Tranfer data over the SPI bus and read the answer.
* \param	data	The data to send.
* \return	The recevied data.
*/
uint8_t SPI_Transmit(uint8_t data);

/**
* \brief	Config the SPI module.
* \param	spcr	The new SPCR register.
* \param	spsr	The new SPSR regiter.
*/
void SPI_Config(uint8_t spcr, uint8_t spsr);
