#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <inttypes.h>

#include "parser.h"
#include "pattern.h"
#include "shift_register.h"
#include "adc.h"
#include "relais.h"
#include "spi.h"
#include "uart.h"


int main(void)
{
	ADC_Init();
	Relais_Init();
	ShiftRegister_Init();
	SPI_Init();
	Uart_Init();
	Pattern_Init();
	Parser_Init();

	wdt_enable(WDTO_250MS);
	sei();

	while(1)
	{
		Parser_Process();
		Pattern_Process();
		wdt_reset();
	}
}
